//////////////////////////////////////////////////////
//
// Division of Applied Robot Technology, KITECH
// Web: http://www.orobot.net
// Written by KwangWoong Yang<page365@gmail.com>
//

#include "stdafx.h"
#include "mm.h"
#include "beacon.h"
#include "diff_wheel_robot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

vector<sBeacon> _beacon;

bool load_beacon (const char *file_name)
{
	_beacon.clear ();
	_beacon.reserve (1000);

	FILE *fp = fopen (file_name, "r");
	if (fp) {
		char word[1024+1], *p;
		while (fgets (word, 1024, fp)) {
			word[1024] = '\0';
			for (p = word; *p==' ' || *p=='\t'; ++p);

			if (*p == '#') continue;

			sBeacon beacon;

			beacon.id = strtol (p, &p, 10);	if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			beacon.x = strtod (p, &p);		if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			beacon.y = strtod (p, &p);		if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			beacon.z = strtod (p, &p);		if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			beacon.r = strtod (p, &p);
			beacon.d = 0;
			beacon.active = false;
			
			_beacon.push_back (beacon);
		}	
		fclose (fp);

		return true;
	}
	return false;
}


void calc_seen_beacon ()
{
	for (unsigned int i=0; i<_beacon.size(); ++i) {
		double dx = _beacon[i].x - _robot_x;
		double dy = _beacon[i].y - _robot_y;
		double dz = _beacon[i].z - 0.;

		_beacon[i].d = sqrt (dx*dx + dy*dy + dz*dz);
		_beacon[i].active = (_beacon[i].d <= _beacon[i].r) ? true : false;
	}
}
