#include "stdafx.h"
#include "mm.h"
#include "ceiling_landmark.h"
#include "diff_wheel_robot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

vector<sCeilingLandmark> _ceiling_landmark;


bool load_ceiling_landmark (const char *file_name)
{
	_ceiling_landmark.clear ();
	_ceiling_landmark.reserve (1000);

	FILE *fp = fopen (file_name, "r");
	if (fp) {
		char word[1024+1], *p;
		while (fgets (word, 1024, fp)) {
			word[1024] = '\0';
			for (p = word; *p==' ' || *p=='\t'; ++p);

			if (*p == '#') continue;

			sCeilingLandmark feature;

			feature.id = strtol (p, &p, 10);			if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			feature.x = strtod (p, &p);					if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			feature.y = strtod (p, &p);					if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			feature.theta = _DEG2RAD*strtod (p, &p);	if (*p=='\r' || *p=='\n' || *p=='\0') continue;
			feature.r = strtod (p, &p);
			feature.active = false;
			
			_ceiling_landmark.push_back (feature);
		}	
		fclose (fp);

		return true;
	}
	return false;
}


void calc_seen_ceiling_landmark ()
{
	for (unsigned int i=0; i<_ceiling_landmark.size(); ++i) {
		double dx = _ceiling_landmark[i].x - _robot_x;
		double dy = _ceiling_landmark[i].y - _robot_y;

		double d = sqrt(dx*dx + dy*dy);

		_ceiling_landmark[i].active = (d <= _ceiling_landmark[i].r) ? true : false;
	}
}

