
// mobile_robot_simulationDlg.h : header file
//

#pragma once


// Cmobile_robot_simulationDlg dialog
class Cmobile_robot_simulationDlg : public CDialog
{
// Construction
public:
	Cmobile_robot_simulationDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_MOBILE_ROBOT_SIMULATION_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

private:
	LARGE_INTEGER _time_prev, _freq;

private:
	int M2Px(double _x);
	int M2Py(double _y);
	int M2Pl(double _d);
	double P2Mx(int _x);
	double P2My(int _y);
	double P2Ml(int _d);

	enum eObjectSel {
		SEL_NONE = 0, SEL_CURRENT, SEL_MAP
	};

	eObjectSel _sel;

	double _scale;
	double _offset_x;
	double _offset_y;
	CPoint _cursorDragStartPt;

	CRect _mapRect;

private:
	void DrawBackground (CDC &dc, int width, int height);
	void DrawMap (CDC &dc);
	void DrawFeature2D (CDC &dc);
	void DrawFeature3D (CDC &dc);
	void DrawRobot (CDC &dc, double x, double y, double theta, double diameter, COLORREF color);
	void DrawScanningLaser (CDC &dc, COLORREF color, bool line);
	void DrawFloorLandmark (CDC &dc);
	void DrawCeilingLandmark (CDC &dc);
	void DrawBeacon (CDC &dc);
	void DrawText (CDC &dc, double dt);

	CDC      _memDC;
	CBitmap  _bitmap;
	CBitmap* _bitmapOld;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnDestroy();

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);

	afx_msg void OnBnClickedButtonLoadMap();
};
